Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.373
diff -u -r1.373 chan_zap.c
--- channels/chan_zap.c	3 Nov 2004 22:37:55 -0000	1.373
+++ channels/chan_zap.c	5 Nov 2004 04:00:04 -0000
@@ -1213,11 +1213,17 @@
 {
 	int x;
 	int res;
+	if (!p)
+		return;
 	if (p->echocanon) {
 		ast_log(LOG_DEBUG, "Echo cancellation already on\n");
 		return;
 	}
-	if (p && p->echocancel) {
+	if (p->digital) {
+		ast_log(LOG_DEBUG, "Echo cancellation isn't required on digital connection\n");
+		return;
+	}
+	if (p->echocancel) {
 		if (p->sig == SIG_PRI) {
 			x = 1;
 			res = ioctl(p->subs[SUB_REAL].zfd, ZT_AUDIOMODE, &x);
